/*
* Politecnico di Milano
* Corso Informatica Medica 2012/2013 - Prof. Santambrogio
* Esercizi di: Alessandro A. Nacci
* E-mail: alessandro.nacci@mail.polimi.it
* Web: www.alessandronacci.com
* ------------------------------------
*/


/****
*
*	ALBERO GENEALOGICO
*	---------------------------------	
*
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_LEN 16
#define MAX_FIGLI 16
#define MAX_PERSONE 256


typedef enum {MASCHIO, FEMMINA} genere;

typedef struct {
	genere sesso;
	char nome[STR_LEN];
	int i_persona;
	int i_genitore1;
	int i_genitore2;
	int i_figli[MAX_FIGLI];
	int numero_figli;
	int eta;
} persona;


persona crea_persona(genere sesso, char nome[STR_LEN], int eta);
int aggiungi_a_popolazione(persona* popolazione[MAX_PERSONE], persona* p, int* cardinalita_popolazione);
void aggiungi_figlio(persona* genitore, persona* figlio);
void elenca_figli_nipoti(persona* popolazione[MAX_PERSONE], persona* p, genere sesso, int eta_minima);

int main () 
{

	persona* popolazione[MAX_PERSONE];
	int cardinalita_popolazione = -1;

	persona p0 = crea_persona(MASCHIO, "MARCO", 50);
	persona p1 = crea_persona(FEMMINA, "STEFANIA", 49);
	persona p2 = crea_persona(MASCHIO, "LUCA", 30);
	persona p3 = crea_persona(MASCHIO, "PIPPO", 26);
	persona p4 = crea_persona(FEMMINA, "LUCIA", 53);
	persona p5 = crea_persona(FEMMINA, "ARIANNA", 30);
	persona p6 = crea_persona(MASCHIO, "RINALDO", 32);
	persona p7 = crea_persona(MASCHIO, "STEFANO", 10);

	aggiungi_a_popolazione(popolazione, &p0, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p1, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p2, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p3, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p4, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p5, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p6, &cardinalita_popolazione);
	aggiungi_a_popolazione(popolazione, &p7, &cardinalita_popolazione);


	// Marco e' padre di LUCA e di PIPPO
	aggiungi_figlio(popolazione[0], popolazione[2]);
	aggiungi_figlio(popolazione[0], popolazione[3]);

	// Stefania e' madre di LUCA e di PIPPO
	aggiungi_figlio(popolazione[1], popolazione[2]);
	aggiungi_figlio(popolazione[1], popolazione[3]);

	// Arianna e' figlia di Marco e Lucia
	aggiungi_figlio(popolazione[0], popolazione[5]);
	aggiungi_figlio(popolazione[4], popolazione[5]);

	// Stefano e' figlio di Arianna e Rinaldo
	aggiungi_figlio(popolazione[5], popolazione[7]);
	aggiungi_figlio(popolazione[6], popolazione[7]);


	elenca_figli_nipoti(popolazione, popolazione[0], MASCHIO, 3);

	return 0;

}


persona crea_persona(genere sesso, char nome[STR_LEN], int eta)
{
	persona p;
	p.sesso = sesso;
	strcpy(p.nome,nome);
	p.i_genitore1 = -1;
	p.i_genitore2 = -1;
	p.numero_figli = 0;
	p.eta = eta;
	return p;
}

int aggiungi_a_popolazione(persona* popolazione[MAX_PERSONE], 
	persona* p, int* cardinalita_popolazione)
{
	(*cardinalita_popolazione)++;
	p->i_persona = *cardinalita_popolazione;
	popolazione[*cardinalita_popolazione] = p;
}

void aggiungi_figlio(persona* genitore, persona* figlio)
{
	genitore->i_figli[genitore->numero_figli] = figlio->i_persona;
	genitore->numero_figli++;

	if (figlio->i_genitore1 == -1)
		figlio->i_genitore1 = genitore->i_persona;
	else if (figlio->i_genitore2 == -1)
		figlio->i_genitore2 = genitore->i_persona;
	else
		printf("errore\n");

}

char* genere_to_str(genere sesso)
{
	if (sesso == MASCHIO) return "MASCHIO";
	if (sesso == FEMMINA) return "FEMMINA";
	return "?";
}

void stampa_persona(persona* p)
{
	printf("Nome: %s - Genere: %s - Eta':%d - Id:%d - #Figli: %d\n", 
	p->nome, genere_to_str(p->sesso), p->eta, p->i_persona, p->numero_figli);
}

void elenca_figli_nipoti(persona* popolazione[MAX_PERSONE], 
	persona* p, genere sesso, int eta_minima)
{

	int i;

	if (p->sesso == sesso && p->eta >= eta_minima)
		stampa_persona(p);


	for (i = 0; i < p->numero_figli; i++)
	{
		persona* f = popolazione[p->i_figli[i]];
		elenca_figli_nipoti(popolazione, f, sesso, eta_minima);
	}
}


